import { GraphQLFieldConfig, GraphQLInputFieldConfig, GraphQLArgumentConfig, GraphQLEnumType } from 'graphql';
import { MergeTypeCandidate, MergeFieldConfigCandidate, MergeInputFieldConfigCandidate, TypeMergingOptions } from './types';
export declare function validateFieldConsistency(finalFieldConfig: GraphQLFieldConfig<any, any>, candidates: Array<MergeFieldConfigCandidate>, typeMergingOptions: TypeMergingOptions): void;
export declare function validateInputObjectConsistency(fieldInclusionMap: Record<string, number>, candidates: Array<MergeTypeCandidate>, typeMergingOptions: TypeMergingOptions): void;
export declare function validateInputFieldConsistency(finalInputFieldConfig: GraphQLInputFieldConfig, candidates: Array<MergeInputFieldConfigCandidate>, typeMergingOptions: TypeMergingOptions): void;
export declare function validateTypeConsistency(finalElementConfig: GraphQLFieldConfig<any, any> | GraphQLArgumentConfig | GraphQLInputFieldConfig, candidates: Array<GraphQLFieldConfig<any, any> | GraphQLArgumentConfig | GraphQLInputFieldConfig>, definitionType: string, settingNamespace: string, typeMergingOptions: TypeMergingOptions): void;
export declare function validateInputEnumConsistency(inputEnumType: GraphQLEnumType, candidates: Array<GraphQLArgumentConfig | GraphQLInputFieldConfig>, typeMergingOptions: TypeMergingOptions): void;
